UNIT BGIload;
{ c Petr Mikulk }
{$F+,O+,S-,X+,D-,L-,R-}

INTERFACE

uses graph, BGIdriv, BGIfont;

procedure RegisterCGA;
procedure RegisterEGAVGA;
procedure RegisterSVGA16;


IMPLEMENTATION

procedure Abort(Msg : string);
begin
writeln('Ouha:', Msg, ': ', GraphErrorMsg(GraphResult));
Halt(1);
end;

procedure RegisterCGA;
begin
if RegisterBGIdriver(@CGADriverProc) < 0 then
  Abort('CGA');
end;

procedure RegisterEGAVGA;
begin
if RegisterBGIdriver(@EGAVGADriverProc) < 0 then
  Abort('EGA/VGA');
end;

procedure RegisterSVGA16;
begin
if RegisterBGIdriver(@SVGA16DriverProc) < 0 then
  Abort('SVGA16');
end;

(************************** IMPORTANT (??) NOTE *******************
 svga16 comes from a svga package by  hargrave@dellgate.us.dell.com
 It is a shareware package, so one should pay for it. 
 That is not my case, since I use the egavga.bgi driver; I had not 
 time to implement the mouse support for svga16. 
   One can live without this driver.
*******************************************************************)

begin
{ Register all the drivers }
RegisterEGAVGA;
{ if RegisterBGIdriver(@EGAVGADriverProc) < 0 then Abort('EGA/VGA'); }
InstallUserDriver ('Svga16', nil);
{ if RegisterBGIdriver(@SVGA16DriverProc) < 0 then Abort('SVGA16'); }
RegisterCGA;
{ if RegisterBGIdriver(@CGADriverProc) < 0 then Abort('CGA'); }

{ Register all the fonts }
if RegisterBGIfont(@SansSerifFontProc) < 0 then
  Abort('SansSerif')
end.
