UNIT DefFloat;
{ c Petr Mikulk - Brno - 1991 }
{ Unita nadefinuje typ Float podle toho, zda je v Options Compiler 
  pozadavek na $N+,$E+ 
  Budou-li vsechny unity (treba od doc. Celeho) tuto unitu pouzivat, nebudou
  problemy s kompatibilitou dat - float bude ve vsech unitach tentyz.
}

{S-,D-,L-,R-}

(****
{$IFDEF CPU87} {$N+} {$ELSE} {$N-} {$ENDIF}
*****)

{ $DEFINE FloatDouble}
{ ***** if FloatDouble is defined, then float=double,  ******
  ***** else float=real                                ******}

INTERFACE

{$IFDEF FloatDouble}
const
  _eps     = 1.1E-19; _sqrteps = 3.3E-10;
  _minflt = 5.0e-324; _maxflt  = 1.7e+308;
type
  float   = double;

{$ELSE}
const
  _eps     = 2.0E-12; _sqrteps = 1.4E-6;
  _minflt = 2.94E-39;  _maxflt  = 1.7E+38;
type
  float   = real;

{$ENDIF}

const
  _minreal = 2.94E-39;  _maxreal = 1.7E+38;

IMPLEMENTATION

end. { DefFloat }
