UNIT TVFibHev;
{ c Petr Mikulk - Brno - 1992 }
{ (lokalni) procedury pro handle event }

{$F+,O+,S-,X+,D-,L-,R-}
{ $F+,O+,S-,X+,D+,L+,R+}

INTERFACE

uses dos, crt,
     Objects, Drivers, Memory, Views, Dialogs, Buffers,
     ZprBox, NormDlg, TRuzne, TUnita, Kalk, {FViewU,} App1,
     DefFloat, ElFun, PmElFun,
     TVFibDef, TVFibIni, TVFibDat, {TVFibEd,} TVFibHlp, Editor;


type

  TLastApp = object ( TFibHlpApp ) end;

  PFibHevApp = ^ TFibHevApp;
  TFibHevApp = object ( TLastApp )
    constructor Init;
    procedure MakeSaveBeforeDOS;
    procedure MakeLatexKbd ( Helpni: boolean );
    procedure MakeGrErrorSkip;
    procedure DosShell;
    procedure DosCommandX;
    procedure DosCommand ( WhatToRun, WhatToWrite: PathStr; WaitAfter: boolean );
{    procedure Prohlidni ( var Name: PathStr );
     procedure ShowFile; }
    procedure DosGraf ( I: integer );
    procedure Kalkulacka;
    procedure Nevypinej;
    procedure ChangeSwitchOffMin;
    procedure ChangeTabSpaces;
    procedure Vynasoby;
    procedure Vynasobx;
    procedure TextCapture;
    procedure ChangeScreenMode;
    procedure GotoLineNb ( Cislo: integer ); { if < 1 then se zepta na to cislo }
    procedure SaveAll;
    procedure ShowUserScreen;
    function OpenEditor(FileName: FNameStr; Visible: boolean): PEditWindow;
      virtual;
    end;

  PNevypinat = ^ TNevypinat;
  TNevypinat = object ( TWindow )
    procedure Draw; virtual;
    procedure close; virtual;
    end;

const NevypinatP: PNevypinat = nil;

IMPLEMENTATION

{ --- TNevypinat --- }

procedure TNevypinat.Draw;
const TA=16*black+LightRed;
var R: TRect; B,B2: TDrawBuffer; S: PathStr;
begin
TWindow.Draw;
Palette:=wpGrayWindow;
MoveChar(B2,' ',TA,Size.X); WriteLine(1,1,Size.X-2,Size.Y-2,B2);
{ B:=B2; S:='Bezi vypocet, nevypinejte prosim pocitac !'; }
B:=B2; S:='The computer is working, do not switch it off, please !';
MoveStr(B,S,TA); WriteLine(15,3,length(S),1,B);
B:=B2; S:='Thank you.'; MoveStr(B,S,TA); WriteLine(33,4,length(S),1,B);
end;

procedure TNevypinat.close;
begin
TWindow.close;
NevypinatP:=nil
end;


{ --- TFibHevApp --- }

constructor TFibHevApp.Init; var I: integer;
begin
I:=1; while (I<=ParamCount) and (ParamStr(I)<>'/-') do inc(I);
GrafDialogEnable:=not((I<=ParamCount) and (ParamStr(I)='/-'));
TLastApp.Init;
if GrafDialogEnable
  then begin GrafDialogP:=MakeGrafDialog;
       DeskTop^.Insert(GrafDialogP) end
{ else GrafDialogP:=nil  by jiz melo byt pri inicializaci objektu }
end;


{ --- HandleEvent --- }


procedure TFibHevApp.DosShell;
begin
if YesSaveBeforeDOS then SaveAll;
DoneSysError;DoneEvents;DoneVideo;DoneMemory;SetMemTop(Ptr(BufHeapPtr, 0));
FreeMemBump;
if UsrScrBuf<>nil then
  begin Move(UsrScrBuf^,ScreenBuffer^,UsrScrBufSize);
  gotoXY(UsrCursX,UsrCursY) end;
PrintStr('** Type EXIT to return to PMGRAF **');
SwapVectors; Exec(GetEnv('COMSPEC'), ''); SwapVectors;
if UsrScrBuf<>nil then
   begin Move(ScreenBuffer^,UsrScrBuf^,UsrScrBufSize);
   UsrCursX:=WhereX; UsrCursY:=WhereY end;
GetMemBump;
SetMemTop(Ptr(BufHeapEnd, 0)); InitMemory;InitVideo;InitEvents;InitSysError;
Application^.Redraw end;

procedure TFibHevApp.DosCommand ( WhatToRun, WhatToWrite: PathStr; WaitAfter: boolean );
begin
if YesSaveBeforeDOS then SaveAll;
DoneSysError;DoneEvents;DoneVideo;DoneMemory;SetMemTop(Ptr(BufHeapPtr, 0));
FreeMemBump;
if UsrScrBuf<>nil then
  begin Move(UsrScrBuf^,ScreenBuffer^,UsrScrBufSize);
  gotoXY(UsrCursX,UsrCursY) end;
if WhatToWrite<>'' then PrintStr(WhatToWrite);
SwapVectors; Exec(GetEnv('COMSPEC'), '/C '+WhatToRun); SwapVectors;
if UsrScrBuf<>nil then
   begin Move(ScreenBuffer^,UsrScrBuf^,UsrScrBufSize);
   UsrCursX:=WhereX; UsrCursY:=WhereY end;
if WaitAfter then begin PrintStr('Press any key to go back...'); repeat until KeyPressed; ReadKey end;
GetMemBump;
SetMemTop(Ptr(BufHeapEnd, 0)); InitMemory;InitVideo;InitEvents;InitSysError;
Application^.Redraw end;

const PrevDosCommandX: PathStr='vc';
procedure TFibHevApp.DosCommandX;
begin
if ExecDialog(new(PStringDialog,Init('Execute command','Enter DOS command',40,hlDOS)),@PrevDosCommandX) = cmCancel then exit;
DosCommand( PrevDosCommandX, '', true );
end;


{
procedure TFibHevApp.Prohlidni ( var Name: PathStr );
var PF: PFileWindow; label Konec;
begin
SetMemTop(Ptr(BufHeapPtr, 0));
FreeMemBump;
if not FileExist(Name) then
  begin ZpravaBox('','File '+Name+' not found.',nil,mfYesButton+mfNoButton);
  goto Konec end;
PF:=new(PFileWindow,Init(Name)); PF^.Palette:=wpCyanWindow;
DeskTop^.Insert(PF);
Konec:
GetMemBump; SetMemTop(Ptr(BufHeapEnd, 0));
end;

procedure TFibHevApp.ShowFile;
const Name: PathStr='*.*';
begin
if ExecDialog(new(PFileDialog,Init('*.*','View file','~N~ame',fdOpenButton,100)),@Name) = cmCancel then exit;
Prohlidni(Name)
end;
}

procedure TFibHevApp.Kalkulacka;
begin DeskTop^.Insert( new( PCalculatorWAE, Init(54,2) )) end;

procedure TFibHevApp.Nevypinej;
var R: TRect;
begin
if NevypinatP=nil then
  begin R.assign(1,1,79,13);
  NevypinatP:=new( PNevypinat,Init(R,'',0));
  NevypinatP^.SetState(sfShadow,false);
  DeskTop^.Insert(NevypinatP) end;
NevypinatP^.Select
end;

procedure TFibHevApp.ChangeSwitchOffMin;
begin
ExecDialog(new(PLongIntDialog,Init('','Switch off after [min]',32,0,MaxLongInt)),@SwitchOffMin)
end;

procedure TFibHevApp.ChangeTabSpaces;
var Pom: longint;
begin
Pom:=TabSpaces;
ExecDialog(new(PLongIntDialog,Init('Tabulator','Enter 0 for TAB, else nb. of spaces',35,0,255)),@Pom);
TabSpaces:=Pom
end;


procedure TFibHevApp.Vynasoby; var I: integer; const R: real = 1; Add: real = 0;
begin
if ExecDialog(new(PRealDialog,Init(' Linear change of y','  1. Add ',25,-_maxreal,_maxreal)),@Add) = cmCancel then exit;;
if ExecDialog(new(PRealDialog,Init(' Linear change of y','  2. Multiply by',25,-_maxreal,_maxreal)),@R) = cmCancel then exit;;
for I:=1 to ZpracHodnot do
  HodnotyIntenzity^[I]:=(HodnotyIntenzity^[I]+Add)*R;
end;

procedure TFibHevApp.Vynasobx; var I: integer; const R: real = 1; Add: real = 0;
begin
if ExecDialog(new(PRealDialog,Init(' Linear change of x','  1. Add ',25,-_maxreal,_maxreal)),@Add) = cmCancel then exit;;
if ExecDialog(new(PRealDialog,Init(' Linear change of x','  2. Multiply by',25,-_maxreal,_maxreal)),@R) = cmCancel then exit;;
for I:=1 to ZpracHodnot do
  HodnotyEtha^[I]:=DegToRad( (RadToDeg(HodnotyEtha^[I])*3600+Add)*R /3600);
end;

procedure TFibHevApp.TextCapture;
var FileName: PathStr; type XPolar=array[0..3000] of char;
var Out: text; I: integer;
begin
Beep; UsrScrBufSize:=2*ScreenHeight*ScreenWidth;
SaveUserScreen; Beep;
FileName:='*.txt';
if ExecDialog(new(PFileDialog,Init('*.txt','Screen save to','~N~ame',fdOpenButton,100)),@FileName) = cmCancel then exit;
assign(Out,FileName); rewrite(Out);
for I:=0 to UsrScrBufSize div 2 do
  begin write(Out,XPolar(UsrScrBuf^)[2*I]);
  if I mod ScreenWidth = ScreenWidth-1 then writeln(Out) end;
close(Out);
end;


procedure TFibHevApp.ChangeScreenMode;
begin
if MyScreenMode<>43
   then begin SetScreenMode(259); ScreenMode:=43;
        MyScreenMode:=43 end
   else begin SetScreenMode(smCO80); ScreenMode:=25;
        MyScreenMode:=25 end;
Application^.ReDraw;
end;


const LineJump: longint = 1;
procedure TFibHevApp.GotoLineNb ( Cislo: integer );
var Line: integer; P: PView; E: PFileEditor;
begin
P:=DeskTop^.First;
{ if TypeOf(P^)<>TypeOf(TEditWindow) then
  begin beepni(10); exit end;}
if Cislo < 1 then
  begin if ExecDialog(new(PLongIntDialog,Init('','Goto line number',16,1,MaxInt)),@LineJump)<>cmOK then exit;
  Cislo:=LineJump end;
E:=PEditWindow(P)^.Editor;
E^.GotoLine(Cislo)
end;

procedure TFibHevApp.SaveAll;
var F,P: PView;
begin
  F:=DeskTop^.First; P:=F;
  repeat
  if TypeOf(P^)=TypeOf(TEditWindow) then
    with PEditWindow(P)^.Editor^ do if Modified then SaveFile;
  P:=P^.Next;
  until P=F;
end;

procedure TFibHevApp.MakeSaveBeforeDOS;
begin
YesSaveBeforeDOS:=not YesSaveBeforeDOS;
DisposeStr(ItemSaveBeforeDOS^.Name);
ItemSaveBeforeDOS^.Name:=NewStr(GetSaveBeforeDOSstring);
end;

procedure TFibHevApp.MakeLatexKbd ( Helpni: boolean );
begin
TeXkbdOn:=not TeXkbdOn;
DisposeStr(ItemLatexKbd^.Name);
ItemLatexKbd^.Name:=NewStr(GetLatexKbdString);
if Helpni and TeXkbdOn then Help2
end;

procedure TFibHevApp.MakeGrErrorSkip;
begin
GrErrorSkip:=1-GrErrorSkip;
DisposeStr(ItemGrErrorSkip^.Name);
ItemGrErrorSkip^.Name:=NewStr(GetGrErrorSkipstring);
end;

procedure TFibHevApp.ShowUserScreen;
begin
if UsrScrBuf=nil then exit;
HideMouse;
Move(UsrScrBuf^,ScreenBuffer^,UsrScrBufSize);
gotoXY(UsrCursX,UsrCursY);
ShowMouse;
repeat until KeyPressed; ReadKey;
Application^.Redraw;
end;

procedure TFibHevApp.DosGraf ( I: integer );
begin
DosCommand(DosCommandI[I],'',false); KresliGraf;
end;

function TFibHevApp.OpenEditor(FileName: FNameStr; Visible: boolean): PEditWindow;
begin end;


begin
NevypinatP:=nil;
end. { TVFibHev }

