UNIT TUnita;
{$F+,O+,S-,X+,D-,L-,R-}

{ c Petr Mikulik - Brno - 1991 }

(***************************************************************************
 * Ruzne funkce a views a windows pro Turbo Vision                         *
 **************************************************************************)


INTERFACE

uses crt, dos, Objects, Drivers, Views, Gadgety, App1;

type PTimeView = ^TTimeView;
     TTimeView = object(TView)
                 LastSec,LastMinute: Word;
                 Disp: string[5];
                 procedure Draw; virtual;
                 procedure UpDate; virtual;
                 end;

type PTimeApp = ^TTimeApp;
     TTimeApp = object(TApplication)
                Clock: TTimeView;
                constructor Init;
                procedure Idle; virtual;
                end;

type PDateView = ^TDateView;
     TDateView = object(TView)
                 procedure Draw; virtual;
                 constructor Init;
                 end;

type PDemoView = ^TDemoView;
     TDemoView = object(TView)
                 procedure Draw; virtual;
                 end;

type PDemoWindow = ^TDemoWindow;
     TDemoWindow = object(TWindow)
                   constructor Init;
                   end;

type TGadgetApp = object ( TApplication )
                  Heap: PHeapView;
                  Clock: PClockView;
                  constructor Init;
                  procedure Idle; virtual;
                  end;

IMPLEMENTATION

{ -------- TTimeView --------- }

procedure TTimeView.Draw;
var Hour,Pom: Word;
begin
{ if odd(LastSec) then Disp[3]:='.' else Disp[3]:=':'; verze blikani :. }
WriteStr(0,0,Disp,1) end;

procedure TTimeView.UpDate;
var Hour,Min,Sec,Pom: Word; S2: string;
begin
GetTime(Hour,Min,Sec,Pom);
if LastMinute<>Min then
   begin LastMinute:=Min; str(Hour:2,Disp);
   str(LastMinute:1,S2); if LastMinute=0 then S2:='0';
   if LastMinute<10 then Disp:=Disp+':0'+S2 else Disp:=Disp+':'+S2; end;
{ if Sec<>LastSec then begin LastSec:=Sec; Draw end; }
if (Disp[3]=':') and (Pom>49)
   then begin Disp[3]:=' '; Draw end
   else if (Disp[3]=' ') and (Pom<50)
           then begin Disp[3]:=':'; Draw end
end;

{ -------- TTimeApp ---------- }

constructor TTimeApp.Init;
var R: TRect;
begin
TApplication.Init;
R.assign(74,0,79,1); Clock.Init(R);
Insert(@Clock);
end;

procedure TTimeApp.Idle;
begin TApplication.Idle; Clock.UpDate end;

{ -------- TDateView ---------- }

constructor TDateView.Init; var R: TRect;
begin R.assign(59,0,72,1); TView.Init(R) end;

procedure TDateView.Draw;
var R,M,D,T: Word; S: string[13]; S2: string[4];
begin GetDate(R,M,D,T);
case T of 0:S:='Ne';1:S:='Po';2:S:='=t';3:S:='St';4:S:='t';5:S:='P';6:S:='So'; end;
str(D:1,S2); S:=S+#32+S2+'.'; str(M:1,S2); S:=S+S2+'.'; str(R:1,S2); S:=S+S2; WriteStr(0,0,S,1); end;

{ -------- TDemoView ---------- }

procedure TDemoView.Draw; var R: TRect; B: TDrawBuffer;
begin MoveChar(B,' ',$40,Size.X); WriteLine(0,0,Size.X,Size.Y,B);
WriteStr(4,3,'Tento  program',14); WriteStr(2,4,'je pouze demonstran.',14);
WriteStr(2,5,'Nen uren k en !',14); WriteStr(7,7,'c Petr Mikulk',15) end;

{ -------- TDemoWindow ---------- }

constructor TDemoWindow.Init; var R: TRect;
begin R.assign(0,0,30,11); Randomize;
R.Move(Random(57),Random(16)); TWindow.Init(R,'Pozor !',0);
Flags:=Flags and not wfGrow;
GetExtent(R); R.Grow(-1,-1); Insert(new(PDemoView,Init(R))) end;

{ -------- TGadgetApp --------- }

constructor TGadgetApp.Init;
var R: TRect;
begin
TApplication.Init;
{ R.assign(ScreenWidth-15,ScreenHeight-1,ScreenWidth-6,ScreenHeight); }
R.assign(ScreenWidth-9,0,ScreenWidth,1);
Clock:=new(PClockView,Init(R)); Insert(Clock);
R.assign(ScreenWidth-7,ScreenHeight-1,ScreenWidth-1,ScreenHeight);
Heap:=new(PHeapView,Init(R)); Insert(Heap);
end;

procedure TGadgetApp.Idle;
begin TApplication.Idle;
Heap^.UpDate; Clock^.UpDate; end;

end. { TUNITA }
